/*
 * This file is part of BukkitHTTPD.
 * Copyright (C) 2011 "codename_B" Ben Smith <BenBenBen001@googlemail.com>
 * Copyright (C) 2011 Thomas "V10lator" Rohloff <v10lator@myway.de>
 * 
 *
 * BukkitHTTPD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * BukkitHTTPD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BukkitHTTPD.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.V10lator.BukkitHTTPD;

import java.util.HashMap;

/**
 * 
 * @author V10lator
 * 
 */
public abstract class BukkitHTTPD_API
{
  static BukkitHTTPD plugin = null;
  static final HashMap<String, Function> functions = new HashMap<String, Function>();
  
  static void initialize(BukkitHTTPD interf)
  {
	plugin = interf;
  }
  
  public static boolean isInitialized()
  {
	if(plugin == null)
	  return false;
	return true;
  }
  
  public static boolean addFunction(String name, Function function)
  {
	if(functions.containsKey(name) || functions.containsValue(function))
	  return false;
	functions.put(name, function);
	return true;
  }
  
  public static void removeFunction(String name)
  {
	functions.remove(name);
  }
  
  public static boolean replaceFunction(String name, Function function)
  {
	if(!functions.containsKey(name))
	  return false;
	functions.put(name, function);
	return true;
  }
}
